
var sMaskSet = 'aAlLn?'
var sUAscii = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
var bStarting = true;

// mask elements:
/*
a Lowercase or uppercase letters, or the numbers 0 to 9.
A Uppercase letters or the numbers 0 to 9.
l Lowercase or uppercase letters, but not numbers.
L Uppercase letters, but not numbers.
n Only the numbers 0 to 9.
? Any printable character.
*/


function doKeyDown(e, textbox, sMask) {
 // trap and cancel keys that are not appropriate
 var iKeyCode = 0;  // collect key code
 if (window.event) iKeyCode = window.event.keyCode;
 else if (e) iKeyCode = e.which;
// writeKey(iKeyCode);
 if (iKeyCode == 32 || iKeyCode == 36 || iKeyCode == 39 ||iKeyCode == 37 || iKeyCode == 35
 || iKeyCode == 8 || iKeyCode == 9|| iKeyCode == 46)
  return true;    // space home left right end backspace tab delete
 if (iKeyCode < 47)  // non-printable character
  return false;
}


function getCaretPos(el) {
var rng, ii=-1;
if(typeof el.selectionStart=="number") {
ii=el.selectionStart;
} else if (document.selection && el.createTextRange){
rng=document.selection.createRange();
rng.collapse(true);
rng.moveStart("character", -el.value.length);
ii=rng.text.length;
}
return ii;
}

function doKeyPress(e, textbox, sMask) {

 window.status = '';
 var iKeyCode = 0;  // collect key code
 if (window.event) iKeyCode = window.event.keyCode;
 else if (e) iKeyCode = e.which;

// writeKey(iKeyCode);
 if (iKeyCode == 0 ||iKeyCode == 32 || iKeyCode == 36 || iKeyCode == 39 ||iKeyCode == 37 || iKeyCode == 35
 || iKeyCode == 8 || iKeyCode == 9|| iKeyCode == 46)
  return true;    // space home left right end backspace tab delete
//alert("1:"+iKeyCode);
 // check if mask already filled, and not backspace
 var iLength = textbox.value.length;
 if ((iLength == sMask.length) && !(iKeyCode == 32 || iKeyCode == 36 || iKeyCode == 39 ||iKeyCode == 37 || iKeyCode == 35
 || iKeyCode == 8 || iKeyCode == 9|| iKeyCode == 46))
  return false;
//alert("2:"+iKeyCode);

 var cursorPos = getCaretPos(textbox);
 // get mask character for this position in textbox
 var sMaskChar = sMask.charAt(cursorPos); // iLength);
//writeKey("Go if"+iKeyCode);

 // see if it's a special character
 if (sMaskSet.indexOf(sMaskChar) > -1) {
//alert("1:"+iKeyCode+" mackchar: "+sMaskChar);

  // masked character required
  switch (sMaskChar) {

   case 'a':  // any alphanumeric character
    if ((iKeyCode > 47 && iKeyCode < 58)
    || (iKeyCode > 64 && iKeyCode < 91)
    || (iKeyCode > 96 && iKeyCode < 123))
     return true
    else return false;

   case 'A':  // uppercase alphanumeric character
    if ((iKeyCode > 47 && iKeyCode < 58)
    || (iKeyCode > 64 && iKeyCode < 91))
     return true
    else if (iKeyCode > 96 && iKeyCode < 123) {
     textbox.value += sUAscii.charAt(iKeyCode - 97);
     return false;
    }
    else return false;

   case 'l':  // any letter
    if ((iKeyCode > 64 && iKeyCode < 91)
    || (iKeyCode > 96 && iKeyCode < 123))
     return true
    else
     return false;

   case 'L':  // uppercase letter
    if (iKeyCode > 64 && iKeyCode < 91)
     return true
    else if (iKeyCode > 96 && iKeyCode < 123) {
     textbox.value += sUAscii.charAt(iKeyCode - 97);
     return false;
    }
    else return false;

   case 'n':  // any numeric character
    if (iKeyCode > 47 && iKeyCode < 58)
     return true
    else return false;
   case '?':  // any character
    return true;

   default: return false;
  }
 }
 else
  return true;
}

function doKeyUp(e, textbox, sMask) {
}


function doFocus(e, textbox, sMask) {
 bStarting = true;
 doKeyUp(e, textbox, sMask);
 bStarting = false;
}

// code from: http://www.samspublishing.com/articles/article.asp?p=173412


<!-- Original:  Cyanide_7 (leo7278@hotmail.com) -->
<!-- Web Site:  http://members.xoom.com/cyanide_7 -->

<!-- This script and many more are available free online at -->
<!-- The JavaScript Source!! http://javascript.internet.com -->
<!-- usage: onKeyUp="return autoTab(this, 3, event);"  -->

<!-- Begin
var isNN = (navigator.appName.indexOf("Netscape")!=-1);
function autoTab(input,len, e) {
var keyCode = (isNN) ? e.which : e.keyCode; 
var filter = (isNN) ? [0,8,9] : [0,8,9,16,17,18,37,38,39,40,46];
if(input.value.length >= len && !containsElement(filter,keyCode)) {
input.value = input.value.slice(0, len);
input.form[(getIndex(input)+1) % input.form.length].focus();
}
function containsElement(arr, ele) {
var found = false, index = 0;
while(!found && index < arr.length)
if(arr[index] == ele)
found = true;
else
index++;
return found;
}
function getIndex(input) {
var index = -1, i = 0, found = false;
while (i < input.form.length && index == -1)
if (input.form[i] == input)index = i;
else i++;
return index;
}
return true;
}
//  End -->