package nl.amis.jsf.converters;

import java.util.StringTokenizer;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.ConverterException;

import nl.amis.model.Postcode;


public class PostcodeConverterStrong implements Converter {
    public PostcodeConverterStrong() {
    }

    public Object getAsObject(FacesContext facesContext, 
                              UIComponent uiComponent, String string) {
        // strip spaties en maak uppercase                               
        String postcode = removeSpaces(string).toUpperCase();
        // match met de reguliere expressie voor de Nederlandse Postcodes
        if (!postcode.matches("^[0-9]{4}[a-z|A-Z]{2}$")) { 
            throw new ConverterException("Correct Postcode formaat is 9999XX");
        }
        Postcode pc = new Postcode();
        pc.setCijfers(Short.parseShort(postcode.substring(0,4)));
        pc.setLetter(postcode.substring(4));        
        return pc;
    }

    public String getAsString(FacesContext facesContext, 
                              UIComponent uiComponent, Object object) {
        return Short.toString(((Postcode)object).getCijfers())+((Postcode)object).getLetter();
    }
    
    public static String removeSpaces(String s) {
      StringTokenizer st = new StringTokenizer(s," ",false);
      String t="";
      while (st.hasMoreElements()) t += st.nextElement();
      return t;
      }
}
